unit Kochkurve; //  Fraktal_Pflanzen_Generator;
// ermglicht Studium von Fraktalen und Pflanzen 

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ClipBrd, ExtCtrls, Menus, Parameter,
  Info, HilfeRegeln;

 Type  StackInhalt=record
                    X,Y,L,W:Extended;
                   end;
       Stack        = ^StackEintrag;
       StackEintrag = record
                       Eintrag   :StackInhalt;
                       Naechster :Stack;
                      end;
type
  TKurven = class(TForm)
    Bild: TImage;
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Start: TMenuItem;
    Zwischenablage: TMenuItem;
    N1: TMenuItem;
    Ende: TMenuItem;
    Parameter: TMenuItem;
    Hilfe: TMenuItem;
    Info: TMenuItem;
    N2: TMenuItem;
    Hinweise: TMenuItem;
    DateiLesen: TOpenDialog;
    DateiSpeichern: TSaveDialog;
    Laden: TMenuItem;
    Speichern: TMenuItem;
    N5: TMenuItem;
    Quit: TMenuItem;
    Option: TMenuItem;
    Anzeige: TMenuItem;
    LG: TMenuItem;
    N8: TMenuItem;
    Neu: TMenuItem;
    LG2: TMenuItem;
    procedure LG2Click(Sender: TObject);
    procedure NeuClick(Sender: TObject);
    procedure LGClick(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure AblageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EndeClick(Sender: TObject);
    procedure ParameterClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure HinweiseClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure LadenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure BildMouseDown(Sender: TObject; Button: TMouseButton;
                            Shift: TShiftState; X, Y: Integer);
    procedure BildMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure BildMouseUp(Sender: TObject; Button: TMouseButton;
                          Shift: TShiftState; X, Y: Integer);
    procedure QuitClick(Sender: TObject);
    procedure AnzeigeClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormResize(Sender: TObject);
  private
    // Private declarations
    // eigene Variablen
    RechtEck:Array[1..2]of TPoint;
    Verzeichnis:String;
    // eigene Methoden
    procedure CanvasClear;
    function StackLeer(s:Stack):boolean;
    procedure InitStack(var s:Stack);
    procedure Push(var s:Stack;E:StackInhalt);    // Daten auf den Stapel legen
    procedure Pop(var s:Stack;var E:StackInhalt); // Daten vom Stapel nehmen
    procedure ParameterWerte;
  public
    // Public declarations
    Regeln:TStrings;
    Hintergrund,FarbNr:TColor;
    XStart,YStart,Tiefe,DL,StartWinkel,DW:Integer;
    Initiator,GeneratorG,GeneratorE,GeneratorF,GeneratorX,GeneratorY,
    GeneratorW,GeneratorZ:String;
    Abbruch,Blaetter:Boolean;
  end;

var Kurven: TKurven;

implementation
{$R *.DFM}
{$R+,Q+}

 function TKurven.StackLeer(s:Stack):boolean;
  begin StackLeer:=s=nil end;

 procedure TKurven.InitStack(var s:Stack);
  begin s:=NIL end;

 procedure TKurven.Push(var s:Stack;E:StackInhalt);
  var p:Stack;
   begin new(p);p^.Eintrag:=E;p^.Naechster:=s;s:=p end;

 procedure TKurven.Pop(var s:Stack;var E:StackInhalt);
  var p:Stack;
   begin E:=s^.Eintrag;p:=s^.Naechster;dispose(s);s:=p end;

 procedure TKurven.CanvasClear;
  var Rect:TRect;
  begin
   Bild.Canvas.Brush.Color:=Hintergrund;
   Rect:=Bounds(0,0,Bild.Width,Bild.Height);   //  Mae des BildFeldes
   Bild.Canvas.FillRect(Rect);                 //  Feld lschen
  end;

 procedure TKurven.StartClick(Sender: TObject);
  var I,J,L_S1:Integer;
      X,Y,X2,Y2,Laenge,Winkel:Extended;
      Zustand:StackInhalt;           //  X-Koordinate, Y-Koordinate und Winkel
      Stapel:Stack;
      S1,S2:String;
      Wechsel:Boolean;
  begin
   RechtEck[1].X:=-1;RechtEck[1].Y:=-1;
   RechtEck[2].X:=-1;RechtEck[2].Y:=-1;
   S1:=Initiator;L_S1:=Length(S1);Winkel:=StartWinkel;
   Laenge:=DL;X2:=XStart;Y2:=YStart;
   CanvasClear;
   Bild.Canvas.Pen.Style:=psSolid;             //  Linienart
   Bild.Canvas.Pen.Color:=FarbNr;              //  Linienfarbe
   InitStack(Stapel);Abbruch:=False;
   Screen.Cursor:=crHourGlass;
   Bild.Visible:=False;
   Wechsel:=False;
   For I:=1 to Tiefe do                        // Zeichenkette S1 erzeugen
    begin
     S2:='';
     For J:=1 to L_S1 do
        Case S1[J] of
        'G': S2:=S2+GeneratorG;
        'E': S2:=S2+GeneratorE;
        'F': S2:=S2+GeneratorF;
        'X': S2:=S2+GeneratorX;
        'Y': S2:=S2+GeneratorY;
        'W': S2:=S2+GeneratorW;
        'Z': S2:=S2+GeneratorZ;
        '[': S2:=S2+'[';
        ']': S2:=S2+']';
        '+': S2:=S2+'+';
        '-': S2:=S2+'-';
        '!': S2:=S2+'!';
        '|': S2:=S2+'|';
        '\': S2:=S2+'\'+S1[j+1]+S1[j+2];
        '/': S2:=S2+'/'+S1[j+1]+S1[j+2];
        '<': S2:=S2+'<'+S1[j+1]+S1[j+2];
        '>': S2:=S2+'>'+S1[j+1]+S1[j+2];
        end;
     S1:=S2;L_S1:=Length(S1);                  // umspeichern
     if I mod 40=0 then Application.ProcessMessages; // fr Abbruch
     if Abbruch then Exit;
    end;
   if Anzeige.Checked then
    Application.MessageBox(PChar(S1),'Speicherinhalt',MB_OK);
   For J:=1 to L_S1 do                         //  Interpretationsroutine
    begin
     Zustand.X:=X2;Zustand.Y:=Y2;
     Zustand.W:=Winkel;Zustand.L:=Laenge;
     Case Upcase(S1[J]) of
      'F': Laenge:=DL;
      '!': Wechsel:=not Wechsel;
      '+': if Wechsel then Winkel:=Winkel-DW else Winkel:=Winkel+DW; //  Turnleft  w
      '-': if Wechsel then Winkel:=Winkel+DW else Winkel:=Winkel-DW; //  Turnright w
      '|': Winkel:=Winkel+180;
      '/': if Wechsel then Winkel:=Winkel-StrToFloat(S1[j+1]+S1[j+2])
           else Winkel:=Winkel+StrToFloat(S1[j+1]+S1[j+2]); //  Turnleft  nn
      '\': if Wechsel then Winkel:=Winkel+StrToFloat(S1[j+1]+S1[j+2])
           else Winkel:=Winkel-StrToFloat(S1[j+1]+S1[j+2]); //  Turnright nn
      '<': Laenge:=Laenge/10*StrToFloat(S1[j+1]+S1[j+2]);   // *nn/10
      '>': Laenge:=Laenge*10/StrToFloat(S1[j+1]+S1[j+2]);   // /nn/10
      '[': Push(Stapel,Zustand);                            //  Zustand speichern
      ']': if Not StackLeer(Stapel) then
            Begin
             if Blaetter then
              begin
               Bild.Canvas.Brush.Color:=clRed;
               Bild.Canvas.Ellipse(Round(X2),Round(Kurven.ClientHeight-Y2),
                           Round(X2+4),Round(Kurven.ClientHeight-(Y2+4)));
              end;
             Pop(Stapel,Zustand);                           //  Zustand holen
             X2:=Zustand.X;Y2:=Zustand.Y;
             Winkel:=Zustand.W;Laenge:=Zustand.L;
            End;
     end;
     if (S1[J]='F') or (S1[J]='G') then     // gezeichnet wird mit F 
      begin
       X:=X2+Laenge*cos(Winkel/180*pi);
       Y:=Y2+Laenge*sin(Winkel/180*pi);
       With Bild.canvas do
        Begin
         MoveTo(round(X2),round(Kurven.ClientHeight-Y2));
         if S1[J]='G' then MoveTo(round(X),round(Kurven.ClientHeight-Y))
         else LineTo(round(X),round(Kurven.ClientHeight-Y));
        end;
       if J mod 40=0 then Application.ProcessMessages;      // fr Abbruch
       if Abbruch then Exit;
       X2:=X;Y2:=Y;
      end;
    end;
   Screen.Cursor:=crDefault;
   Bild.Visible:=True;
   while not StackLeer(Stapel) do Pop(Stapel,Zustand);
  end;

 procedure TKurven.AblageClick(Sender: TObject);
  var  BildAusschnitt: TBitmap;
       Weite,Hoehe:Integer;
       Ziel,Quelle:TRect;
  begin
   Screen.Cursor:=crHourGlass;
   BildAusschnitt:=TBitmap.Create;
   Weite:=RechtEck[2].X-RechtEck[1].X-2;
   Hoehe:=RechtEck[2].Y-RechtEck[1].Y-2;
   Quelle:=Bounds(RechtEck[1].X+1,RechtEck[1].Y+1,Weite+1,Hoehe+1);
   Ziel:=Bounds(0,0,Weite,Hoehe);
   BildAusschnitt.Width:=Weite;
   BildAusschnitt.Height:=Hoehe;
   BildAusschnitt.Canvas.CopyRect(Ziel,Bild.Picture.Bitmap.Canvas,Quelle);
   Clipboard.Assign(BildAusschnitt);
   BildAusschnitt.Free;
   Screen.Cursor:=crDefault;
  end;

 procedure TKurven.FormCreate(Sender: TObject);
  var Search:TSearchRec;
      NewItem:TMenuItem;
  begin
   Regeln:=TStringList.Create;
   DW:=60;StartWinkel:=0;DL:=10;Tiefe:=3;
   FarbNr:=clGreen;Hintergrund:=clWhite;
   XStart:=Kurven.clientwidth div 4;
   YStart:=2*Kurven.clientHeight div 3;
   Initiator:='F--F--F';
   GeneratorG:='';
   GeneratorE:='';
   GeneratorF:='F+F--F+F';
   GeneratorX:='';
   GeneratorY:='';
   GeneratorW:='';
   GeneratorZ:='';
   Kurven.Caption:='fraktale Kurven und Pflanzen (Schneeflockenkurve)';
   Blaetter:=False;
   StartClick(Self);
   Verzeichnis:=GetCurrentDir;
   ChDir(Verzeichnis+'\Kurven-Definitionen\L-Systeme');
   if FindFirst('*.txt', $23, Search)= 0 then
    repeat
     NewItem:=TMenuItem.Create(Self);
     NewItem.Caption:=copy(Search.Name,1,pos('.',Search.Name)-1);
     LG.Add(NewItem);
     NewItem.OnClick:=LGClick;
     NewItem.RadioItem:=True;
     if NewItem.MenuIndex>0 then
      if NewItem.MenuIndex mod 20=0 then NewItem.Break:=mbBarBreak;
    until FindNext(Search)<>0;
   ChDir(Verzeichnis+'\Kurven-Definitionen\L2-Systeme');
   if FindFirst('*.txt', $23, Search)= 0 then
    repeat
     NewItem:=TMenuItem.Create(Self);
     NewItem.Caption:=copy(Search.Name,1,pos('.',Search.Name)-1);
     LG2.Add(NewItem);
     NewItem.OnClick:=LG2Click;
     NewItem.RadioItem:=True;
     if NewItem.MenuIndex>0 then
      if NewItem.MenuIndex mod 20=0 then NewItem.Break:=mbBarBreak;
    until FindNext(Search)<>0;
  end;

 procedure TKurven.EndeClick(Sender: TObject);
  begin Close end;

 procedure TKurven.ParameterClick(Sender: TObject);
  begin
   ParameterDLG.ShowModal
  end;

 procedure TKurven.NeuClick(Sender: TObject);
  begin
   DW:=0;StartWinkel:=0;
   DL:=10;Tiefe:=0;FarbNr:=Random(16);
   XStart:=Kurven.clientwidth div 2;
   YStart:=Kurven.clientHeight div 2;
   Initiator:='';
   GeneratorG:='';
   GeneratorE:='';
   GeneratorF:='';
   GeneratorX:='';
   GeneratorY:='';
   GeneratorW:='';
   GeneratorZ:='';
   ParameterDLG.InitiatorEdit.Text:=Initiator;
   ParameterDLG.GeneratorGEdit.Text:=GeneratorG;
   ParameterDLG.GeneratorEEdit.Text:=GeneratorE;
   ParameterDLG.GeneratorFEdit.Text:=GeneratorF;
   ParameterDLG.GeneratorXEdit.Text:=GeneratorX;
   ParameterDLG.GeneratorYEdit.Text:=GeneratorY;
   ParameterDLG.GeneratorWEdit.Text:=GeneratorW;
   ParameterDLG.GeneratorZEdit.Text:=GeneratorZ;
   ParameterDLG.TiefeEdit.Value:=Tiefe;
   ParameterDLG.LaengeEdit.Value:=DL;
   ParameterDLG.XEdit.Value:=XStart;
   ParameterDLG.YEdit.Value:=YStart;
   ParameterDLG.RichtungEdit.Value:=StartWinkel;
   ParameterDLG.DWEdit.Value:=DW;
   Kurven.Caption:='fraktale Kurven und Pflanzen (selbst definiertes Fraktal)';
   CanvasClear;
  end;

 procedure TKurven.InfoClick(Sender: TObject);
  begin InfoBox.ShowModal end;

 procedure TKurven.HinweiseClick(Sender: TObject);
  begin RegelnBox.ShowModal end;

 procedure TKurven.FormKeyPress(Sender: TObject; var Key: Char);
  begin
   if Key=#27 then
    begin
     if MessageDlg('Programmabbruch',mtConfirmation,[mbYes,mbNo],0)=mrYes then
      begin
       MessageDlg('Das Zeichnen wird abgebrochen!',mtWarning,[mbOk],0);
       Abbruch:=True;Screen.Cursor:=crDefault;
       Bild.Visible:=True;
      end
    end;
  end;

 procedure TKurven.LadenClick(Sender: TObject);
  var DateiName:String;
      Wo:Integer;
  begin
   ForceCurrentDirectory:=True;
   with DateiLesen do
    begin
     Filter:='Wortdateien (*.txt) |*.txt';
     DefaultExt:='txt';
     InitialDir:='Kurven-Definitionen';
     if Execute then
      begin
       Regeln.Clear;
       Regeln.LoadFromFile(Filename);
       if Regeln.Count<>14 then
        begin
         MessageDlg('Falsche Dateigre!',mtError,[mbOk],0);
         exit
        end;
       DateiName:=ExtractFilename(Filename);
       Wo:=Pos('.',DateiName);
       if Wo>0 then DateiName:=Copy(DateiName,1,Wo-1);
       Kurven.Caption:='fraktale Kurven und Pflanzen ('+DateiName+')';
       ParameterWerte;
      end;
    end
  end;

 procedure TKurven.ParameterWerte;
  begin
   Initiator:=Regeln[0];
   GeneratorG:=Regeln[1];
   GeneratorE:=Regeln[2];
   GeneratorF:=Regeln[3];
   GeneratorX:=Regeln[4];
   GeneratorY:=Regeln[5];
   GeneratorW:=Regeln[6];
   GeneratorZ:=Regeln[7];
   XStart:=StrToInt(Regeln[8]);
   YStart:=StrToInt(Regeln[9]);
   Tiefe:=StrToInt(Regeln[10]);
   DL:=StrToInt(Regeln[11]);
   StartWinkel:=StrToInt(Regeln[12]);
   DW:=StrToInt(Regeln[13]);
   ParameterDLG.InitiatorEdit.Text:=Initiator;
   ParameterDLG.GeneratorGEdit.Text:=GeneratorG;
   ParameterDLG.GeneratorEEdit.Text:=GeneratorE;
   ParameterDLG.GeneratorFEdit.Text:=GeneratorF;
   ParameterDLG.GeneratorXEdit.Text:=GeneratorX;
   ParameterDLG.GeneratorYEdit.Text:=GeneratorY;
   ParameterDLG.GeneratorWEdit.Text:=GeneratorW;
   ParameterDLG.GeneratorZEdit.Text:=GeneratorZ;
   ParameterDLG.TiefeEdit.Value:=Tiefe;
   ParameterDLG.LaengeEdit.Value:=DL;
   ParameterDLG.XEdit.Value:=XStart;
   ParameterDLG.YEdit.Value:=YStart;
   ParameterDLG.RichtungEdit.Value:=StartWinkel;
   ParameterDLG.DWEdit.Value:=DW;
   StartClick(Self);
  end;

 procedure TKurven.LG2Click(Sender: TObject);
  var DatName:String;
  begin
   if Sender<>LG2 then
    begin
     (Sender as TMenuItem).Checked:=True;
     DatName:=(Sender as TMenuItem).Caption;
     Delete(DatName,pos('&',DatName),1); // _ lschen!
     ChDir(Verzeichnis+'\Kurven-Definitionen\L2-Systeme');
     Regeln.Clear;
     Regeln.LoadFromFile(DatName+'.txt');
     if Regeln.Count<>14 then
      begin
       MessageDlg('Falsche Dateigre!',mtError,[mbOk],0);
       exit
      end;
     Kurven.Caption:='fraktale Kurven und Pflanzen ('+DatName+')';
     ParameterWerte;
    end;
  end;

 procedure TKurven.LGClick(Sender: TObject);
  var DatName:String;
  begin
   if Sender<>LG then
    begin
     (Sender as TMenuItem).Checked:=True;
     DatName:=(Sender as TMenuItem).Caption;
     Delete(DatName,pos('&',DatName),1); // _ lschen!
     ChDir(Verzeichnis+'\Kurven-Definitionen\L-Systeme');
     Regeln.Clear;
     Regeln.LoadFromFile(DatName+'.txt');
     if Regeln.Count<>14 then
      begin
       MessageDlg('Falsche Dateigre!',mtError,[mbOk],0);
       exit
      end;
     Kurven.Caption:='fraktale Kurven und Pflanzen ('+DatName+')';
     ParameterWerte;
    end;
  end;

 procedure TKurven.SpeichernClick(Sender: TObject);
  var DateiName:String;
      Wo:Integer;
  begin
   ForceCurrentDirectory:=True;
   with DateiSpeichern do
    begin
     Filter:='Wortdateien (*.txt) |*.txt';
     DefaultExt:='txt';
     Options:=[ofOverwritePrompt];
     InitialDir:='Kurven-Definitionen';
     if Execute then
      begin
       Regeln.Clear;
       Regeln.Add(Initiator);
       Regeln.Add(GeneratorG);
       Regeln.Add(GeneratorE);
       Regeln.Add(GeneratorF);
       Regeln.Add(GeneratorX);
       Regeln.Add(GeneratorY);
       Regeln.Add(GeneratorW);
       Regeln.Add(GeneratorZ);
       Regeln.Add(IntToStr(XStart));
       Regeln.Add(IntToStr(YStart));
       Regeln.Add(IntToStr(Tiefe));
       Regeln.Add(IntToStr(DL));
       Regeln.Add(IntToStr(StartWinkel));
       Regeln.Add(IntToStr(DW));
       Regeln.SaveToFile(Filename);
       DateiName:=ExtractFilename(Filename);
       Wo:=Pos('.',DateiName);
       if Wo>0 then DateiName:=Copy(DateiName,1,Wo-1);
       Kurven.Caption:='fraktale Kurven und Pflanzen ('+DateiName+')';
      end
    end;
  end;

 procedure TKurven.FormDestroy(Sender: TObject);
  begin
   Anzeige.Checked:=False;
   Regeln.Free;
  end;

 procedure TKurven.BildMouseDown(Sender: TObject; Button: TMouseButton;
                                 Shift: TShiftState; X, Y: Integer);
  begin
   if Shift=[ssLeft] then
    begin
     Bild.Canvas.Brush.Style:=bsClear;
     Bild.Canvas.Pen.Mode:=pmNotXor;
     Bild.Canvas.Pen.Style:=psDot;
     Bild.Canvas.Pen.Color:=clBlack;
     if Hintergrund=clBlack then Bild.Canvas.Pen.Color:=clWhite;
     Bild.Canvas.Rectangle(RechtEck[1].X,RechtEck[1].Y,RechtEck[2].X,RechtEck[2].Y);
     RechtEck[1].X:=X;RechtEck[1].Y:=Y;
     RechtEck[2].X:=X;RechtEck[2].Y:=Y;
     Bild.Canvas.Rectangle(RechtEck[1].X,RechtEck[1].Y,RechtEck[2].X,RechtEck[2].Y);
    end;
  end;

 procedure TKurven.BildMouseMove(Sender:TObject;Shift:TShiftState;X,Y:Integer);
  begin
   // verhindert das Zeichnen nach dem Laden einer Datei,
   // wenn diese per DoubleClick geffnet wurde
   if (RechtEck[1].X<0) and (RechtEck[1].Y<0) then exit;
   if Shift=[ssLeft] then
    begin
     Bild.Canvas.Rectangle(RechtEck[1].X,RechtEck[1].Y,RechtEck[2].X,RechtEck[2].Y);
     RechtEck[2].X:=X;RechtEck[2].Y:=Y;
     Bild.Canvas.Rectangle(RechtEck[1].X,RechtEck[1].Y,RechtEck[2].X,RechtEck[2].Y);
    end
  end;

 procedure TKurven.BildMouseUp(Sender: TObject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);
  begin
   Bild.Canvas.Pen.Mode:=pmCopy;
  end;

 procedure TKurven.QuitClick(Sender: TObject);
  begin
   if MessageDlg('Programmabbruch',mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Das Zeichnen wird abgebrochen!',mtWarning,[mbOk],0);
     Abbruch:=True;Screen.Cursor:=crDefault;
     Bild.Visible:=True;
    end
 end;

 procedure TKurven.AnzeigeClick(Sender: TObject);
  begin
   Anzeige.Checked:=not Anzeige.Checked;
  end;

 procedure TKurven.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  begin
   if MessageDlg('Willst du aufhren?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Aristid Lindenmayer verabschiedet sich!',mtInformation,[mbOk],0);
     CanClose:=True
    end
   else CanClose:=False
  end;

 procedure TKurven.FormResize(Sender: TObject);
  begin
   // Bild vergrern
    Bild.Picture:=nil;
    Bild.Width:=Kurven.Width-8;
    Bild.Height:=Kurven.Height-57;
    Bild.Canvas.Rectangle(0,0,Bild.Width, Bild.Height);
    StartClick(Self);
  end;

end.

