unit Parameter;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin, ExtCtrls, Dialogs;

type
  TParameterDLG = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    BevelEingaben: TBevel;
    TiefeEdit: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    LaengeEdit: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    XEdit: TSpinEdit;
    YEdit: TSpinEdit;
    Label5: TLabel;
    Label6: TLabel;
    RichtungEdit: TSpinEdit;
    DWEdit: TSpinEdit;
    Label7: TLabel;
    InitiatorEdit: TEdit;
    Label8: TLabel;
    GeneratorGEdit: TEdit;
    Label9: TLabel;
    GeneratorEEdit: TEdit;
    Label10: TLabel;
    GeneratorFEdit: TEdit;
    Blatt: TCheckBox;
    LabelHF: TLabel;
    LabelZF: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    GeneratorXEdit: TEdit;
    GeneratorYEdit: TEdit;
    HFarben: TColorBox;
    Farben: TColorBox;
    Label13: TLabel;
    Label14: TLabel;
    GeneratorWEdit: TEdit;
    GeneratorZEdit: TEdit;
    procedure DWEditChange(Sender: TObject);
    procedure RichtungEditChange(Sender: TObject);
    procedure YEditChange(Sender: TObject);
    procedure XEditChange(Sender: TObject);
    procedure LaengeEditChange(Sender: TObject);
    procedure TiefeEditChange(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FarbenClick(Sender: TObject);
    procedure HFarbenClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ParameterDLG: TParameterDLG;

implementation
uses Kochkurve;
{$R *.DFM}

 procedure TParameterDLG.CancelBtnClick(Sender: TObject);
  begin Close end;

 procedure TParameterDLG.OKBtnClick(Sender: TObject);
  begin
   if HFarben.Selected=Farben.Selected then
    begin
     MessageDlg('Du siehst doch NICHTS, du Blindfisch!',mtError,[mbRetry],0);
     exit;
    end;
   Kurven.Tiefe:=TiefeEdit.Value;
   Kurven.DL:=LaengeEdit.Value;
   Kurven.XStart:=XEdit.Value;Kurven.YStart:=YEdit.Value;
   Kurven.StartWinkel:=RichtungEdit.Value;Kurven.DW:=DWEdit.Value;
   Kurven.Initiator:=InitiatorEdit.Text;
   Kurven.GeneratorG:=GeneratorGEdit.Text;
   Kurven.GeneratorE:=GeneratorEEdit.Text;
   Kurven.GeneratorF:=GeneratorFEdit.Text;
   Kurven.GeneratorX:=GeneratorXEdit.Text;
   Kurven.GeneratorY:=GeneratorYEdit.Text;
   Kurven.GeneratorW:=GeneratorWEdit.Text;
   Kurven.GeneratorZ:=GeneratorZEdit.Text;
   Kurven.FarbNr:=Farben.Selected;
   Kurven.Hintergrund:=HFarben.Selected;
   Kurven.Blaetter:=Blatt.Checked;
   Kurven.StartClick(Self);
  end;

 procedure TParameterDLG.FormCreate(Sender: TObject);
  begin
   TiefeEdit.Value:=Kurven.Tiefe;
   LaengeEdit.Value:=Kurven.DL;
   XEdit.MaxValue:=Kurven.Bild.Width;
   YEdit.MaxValue:=Kurven.Bild.Height;
   XEdit.Value:=Kurven.XStart;YEdit.Value:=Kurven.YStart;
   RichtungEdit.Value:=Kurven.StartWinkel;DWEdit.Value:=Kurven.DW;
   InitiatorEdit.Text:=Kurven.Initiator;
   GeneratorGEdit.Text:=Kurven.GeneratorG;
   GeneratorEEdit.Text:=Kurven.GeneratorE;
   GeneratorFEdit.Text:=Kurven.GeneratorF;
   GeneratorXEdit.Text:=Kurven.GeneratorX;
   GeneratorYEdit.Text:=Kurven.GeneratorY;
   GeneratorWEdit.Text:=Kurven.GeneratorW;
   GeneratorZEdit.Text:=Kurven.GeneratorZ;
   Farben.Selected:=Kurven.FarbNr;
   HFarben.Selected:=Kurven.Hintergrund;
   Blatt.Checked:=Kurven.Blaetter;
  end;

 procedure TParameterDLG.FarbenClick(Sender: TObject);
  begin Kurven.FarbNr:=Farben.Selected end;

 procedure TParameterDLG.HFarbenClick(Sender: TObject);
  begin Kurven.Hintergrund:=HFarben.Selected end;

 procedure TParameterDLG.TiefeEditChange(Sender: TObject);
  begin
   if TiefeEdit.Text='' then TiefeEdit.Text:='3';
  end;

 procedure TParameterDLG.LaengeEditChange(Sender: TObject);
  begin
   if LaengeEdit.Text='' then LaengeEdit.Text:='10';
  end;

 procedure TParameterDLG.XEditChange(Sender: TObject);
  begin
   if XEdit.Text='' then XEdit.Text:='120';
  end;

 procedure TParameterDLG.YEditChange(Sender: TObject);
  begin
   if YEdit.Text='' then YEdit.Text:='300';
  end;

 procedure TParameterDLG.RichtungEditChange(Sender: TObject);
  begin
   if RichtungEdit.Text='' then RichtungEdit.Text:='0';
  end;

 procedure TParameterDLG.DWEditChange(Sender: TObject);
  begin
   if DWEdit.Text='' then DWEdit.Text:='60';
  end;

end.

